.\" -*- nroff -*-
.\"
.\" Copyright (c) 1996 Doug Rabson
.\"
.\" All rights reserved.
.\"
.\" This program is free software.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE DEVELOPERS ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE DEVELOPERS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD: src/share/man/man9/VOP_TRUNCATE.9,v 1.1.2.1 1999/09/05 11:27:13 peter Exp $
.\"
.Dd July 24, 1996
.Os
.Dt VOP_TRUNCATE 9
.Sh NAME
.Nm VOP_TRUNCATE
.Nd truncate a file
.Sh SYNOPSIS
.Fd #include <sys/vnode.h>
.Ft int
.Fn VOP_TRUNCATE "struct vnode *vp" "off_t length" "int flags" "struct ucred *cred" "struct proc *p"
.Sh DESCRIPTION
.Pp
The arguments are:
.Bl -tag -width length
.It Ar vp
The file to truncate.
.It Ar length
The desired new length of the file.
.It Ar flags
Flags controlling I/O.
.It Ar cred
Credentials of the caller.
.It Ar p
Current process.
.El
.Pp
The size of file
.Fa vp
is set to
.Fa length .
The file can be both truncated and extended by this call.
If
.Fa flags
contains the value
.Dv IO_SYNC
then all writes to the filesystem should complete before the call returns.
This call is used internally by the UFS filesystem as part of its
implementation of
.Xr VOP_SETATTR 9 .
.Sh RETURN VALUES
Zero is returned on success, otherwise an error is returned.
.Sh SEE ALSO
.Xr vnode 9 ,
.Xr VOP_SETATTR 9
.Sh AUTHORS
This man page was written by Doug Rabson.

